summaryrefslogtreecommitdiff
diff options
context:
space:
mode:
authorPaul Sherwood <paul.sherwood@codethink.co.uk>2013-05-28 22:01:16 +0000
committerPaul Sherwood <paul.sherwood@codethink.co.uk>2013-05-28 22:01:16 +0000
commitb786d267ba550d356c720fb90a3a403316c4838d (patch)
tree2272108060e968f09113efdc86c4c9b5bbb8fd2d
parent727c7a1b0f3abae298ad6e313cd517b83fe1f37d (diff)
downloadmorphs-b786d267ba550d356c720fb90a3a403316c4838d.tar.gz
use sloccount instead of wc -l
-rw-r--r--counter.sh50
1 files changed, 44 insertions, 6 deletions
diff --git a/counter.sh b/counter.sh
index 016dd5b..1143639 100644
--- a/counter.sh
+++ b/counter.sh
@@ -1,18 +1,56 @@
+#!/bin/sh
+
+# Copyright (C) 2013 Codethink Limited
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; version 2 of the License.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License along
+# with this program; if not, write to the Free Software Foundation, Inc.,
+# 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
+
+# Remove all chunk artifacts in the cache except the newest. Morph does
+# not currently clean its caches at any point, so this script is necessary
+# to avoid running out of disk space.
+
+set -e
+
+usage() {
+ echo "Usage: counter your-system"
+ echo
+ echo "This counts lines of code for all the chunks in your-system"
+ echo "It's re-runnable, and does morph edit to get each chunk."
+ echo "The process can take a while."
+}
+
+if [ -z $1 ]; then
+ usage
+ exit 0
+fi
+
workspace=$PWD/../..
system=$1
-strata=`cat $system.morph | grep '\"morph\"' | grep -o \"[-a-z0-9]*\", | grep -o '[-a-z0-9]*'`
+strata=`cat $system.morph | grep '\"morph\"' \
+ | grep -o \"[-a-z0-9]*\", \
+ | grep -o '[-a-z0-9]*'`
for stratum in $strata
do
- chunks=`cat $stratum.morph | grep '\"name\"' | grep -o \"[-a-z0-9]*\", | grep -o '[-a-z0-9]*'`
+ chunks=`cat $stratum.morph | grep '\"name\"' \
+ | grep -o \"[-a-z0-9]*\", \
+ | grep -o '[-a-z0-9]*'`
for chunk in $chunks
do
if [ $chunk != $stratum ] && [ $stratum != "build-essential" ] ; then
morph edit --no-git-update $system $stratum $chunk
- cd $workspace/upstream:$chunk
- echo $PWD `git ls-files | xargs cat | wc -l 2>/dev/null`
-# git ls-files | xargs cat | wc -l ;
- cd $workspace/baserock:baserock/morphs
+ echo $chunk, `sloccount $workspace/*:$chunk 2> /dev/null \
+ |grep '(SLOC)' | awk '{ print $NF }' | sed 's/,//'`
fi;
done
done